//--------------------------------------------------------------------
// YUY2YC48̑ݕϊ
// F(F)͂̂܂܂ŃXP[Oϊ
//
// F̕Ԃɂ
// YUY2FF̕ԂȂi2sNZ𓯂Fɂj
// oYUY2FFL2sNZŕςďo
//
// YUV to YC48 ̕ϊ
// y  = ((Y * 19155) >> 10) - 299
// cb = ((U * 18723) >> 10) - 2340
// cr = ((V * 18723) >> 10) - 2340
//
// YC48 to YUV ̕ϊ
// Y = (( y*219+2048) >> 12) + 16
// U = ((cb*224+2048) >> 12) + 128
// V = ((cr*224+2048) >> 12) + 128
//
//--------------------------------------------------------------------
#include <stdint.h>
#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include "color.h"

//---------------------------------------------------------------------
// short^232bitɂ
//---------------------------------------------------------------------
#define MK_INT( A, B ) ( (int)(unsigned short)A | ((int)B << 16) )

//---------------------------------------------------------------------
// _mm_setr_epi16  _mm_insert_epi16 ōČ
//---------------------------------------------------------------------
#define _MM_SETR_EPI16( w0, w1, w2, w3, w4, w5, w6, w7 ) _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_insert_epi16( _mm_cvtsi32_si128( w0 ), w1, 1 ), w2, 2 ), w3, 3 ), w4, 4 ), w5, 5 ), w6, 6 ), w7, 7 )

/*
inline __m128i _MM_SETR_EPI16( const short &w0, const short &w1, const short &w2, const short &w3, const short &w4, const short &w5, const short &w6, const short &w7 )
{
    __m128i t = _mm_cvtsi32_si128( w0 );
    t = _mm_insert_epi16( t, w1, 1 );
    t = _mm_insert_epi16( t, w2, 2 );
    t = _mm_insert_epi16( t, w3, 3 );
    t = _mm_insert_epi16( t, w4, 4 );
    t = _mm_insert_epi16( t, w5, 5 );
    t = _mm_insert_epi16( t, w6, 6 );
    return _mm_insert_epi16( t, w7, 7 );
}
*/

//---------------------------------------------------------------------
// 0`255ɖOa
//---------------------------------------------------------------------
inline int satura8bit( const int &a )
{
    if( a <   0 ) return 0;
    if( a > 255 ) return 255;
    return a;
}

//---------------------------------------------------------------------
// [Xbh] YUY2 -> YC48iXg[gɕϊj
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_pixel2yc_yuy2_scaling( int thread_id, int thread_num, void *param1, void *param2 )
{
    // l[
    const COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;

    // [JϐɃRs[
    const int h         = cpip->h;
    const int w         = cpip->w;
    const int line_size = cpip->line_size;

	// ̂ŁAXbh𔼕ɂė̏Ƀ\[X
	if( thread_id < 0 || thread_num <= 0 ) return; // 肦ȂlȂ̂
	if( thread_id & 0x1 ) return; // eîݎcj
	thread_id = thread_id >> 1;
	thread_num = (thread_num + 1 ) >> 1;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // ϐvZ
    const int pixel_line_size = ((w+1)/2*4);
    PIXEL_YC *ycp = cpip->ycp;
    const unsigned char *pixelp  = (unsigned char *)cpip->pixelp;

    //
    // y  = ((Y * 19155) >> 10) - 299
    // cb = ((U * 18723) >> 10) - 2340
    // cr = ((V * 18723) >> 10) - 2340
    //
    // ό`
    // y0 = ((Y0 *64  *19155 ) >> 16) - 299
    // cb = ((U  *64  *18723 ) >> 16) - 2340
    // y1 = ((Y1 *64  *19155 ) >> 16) - 299
    // cr = ((V  *64  *18723 ) >> 16) - 2340
    //                                  
    //                coe0              coe1
    const __m128i coe0 = _mm_setr_epi16( 19155, 18723, 19155, 18723, 19155, 18723, 19155, 18723 );
    const __m128i coe1 = _mm_setr_epi16( -299, -2340, -299, -2340, -299, -2340, -299, -2340 );

    for( int y = y_start; y < y_end; y++ )
    {
        PIXEL_YC * ycp2 = (PIXEL_YC *)( (BYTE *)ycp + y * line_size );
        const unsigned char * pixelp2 = (unsigned char *)pixelp + y * pixel_line_size;

        int x = 0;

        // o͑̃|C^16byteACgɑB
        // 蔲̂߁ApaddingŒł4byteɑĂ  xȏ̉KvB
        intptr_t padding = (intptr_t)ycp2 & 0xF;
        if( w > 31 && !(padding & 0x3) )
        {
            padding >>= 1; // ̂ɕKvȃsNZ

            _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

            // 1pbN2sNZ
            for( ; x < padding; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( *(DWORD *)pixelp2 );
                xmm0 = _mm_unpacklo_epi8( xmm0,  _mm_setzero_si128() );
                xmm0 = _mm_slli_epi32( xmm0, 6 );
                xmm0 = _mm_mulhi_epi16( xmm0, coe0 );
                xmm0 = _mm_add_epi16( xmm0, coe1 );
                _mm_stream_si32( (int *)ycp2 + 0, _mm_cvtsi128_si32( xmm0 ) );
                _mm_stream_si32( (int *)ycp2 + 1, _mm_cvtsi128_si32( _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 4, 3, 2, 3 ) ) ) );
                _mm_stream_si32( (int *)ycp2 + 2, _mm_cvtsi128_si32( _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 4, 3, 3, 1 ) ) ) );
                pixelp2 += 4;
                ycp2 += 2;
            }
            // o͑ACgĂ
            // 4pbN8sNZ
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i xmm0 = _mm_loadu_si128( (__m128i *)pixelp2 );
                __m128i xmm1 = xmm0;

                xmm0 = _mm_unpacklo_epi8( xmm0,  _mm_setzero_si128() );
                xmm0 = _mm_slli_epi16( xmm0, 6 );
                xmm0 = _mm_mulhi_epi16( xmm0, coe0 );
                xmm0 = _mm_add_epi16( xmm0, coe1 );

                xmm1 = _mm_unpackhi_epi8( xmm1,  _mm_setzero_si128() );
                xmm1 = _mm_slli_epi16( xmm1, 6 );
                xmm1 = _mm_mulhi_epi16( xmm1, coe0 );
                xmm1 = _mm_add_epi16( xmm1, coe1 );

                __m128i lo0 = _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 2, 3, 1, 0 ) );
                __m128i hi0 = _mm_srli_si128( _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 3, 1, 1, 0 ) ), 4 );
                _mm_stream_si128( (__m128i *)ycp2 + 0, _mm_unpacklo_epi64( lo0, hi0 ) );

                __m128i lo1 = _mm_shufflelo_epi16( _mm_srli_si128( xmm0, 8 ), _MM_SHUFFLE( 3, 1, 2, 3 ) );
                __m128i hi1 = _mm_shufflelo_epi16( xmm1, _MM_SHUFFLE( 2, 3, 1, 0 ) );
                _mm_stream_si128( (__m128i *)ycp2 + 1, _mm_unpacklo_epi64( lo1, hi1 ) );

                __m128i lo2 = _mm_slli_si128( _mm_shufflelo_epi16( xmm1, _MM_SHUFFLE( 3, 1, 1, 0 ) ), 4 );
                __m128i hi2 = _mm_shufflehi_epi16( xmm1, _MM_SHUFFLE( 3, 1, 2, 3 ) );
                _mm_stream_si128( (__m128i *)ycp2 + 2, _mm_unpackhi_epi64( lo2, hi2 ) );

                pixelp2 += 16;
                ycp2 += 8;
            }
            // [1pbN2sNZi_mm_stream_si32gpj
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( *(DWORD *)pixelp2 );
                xmm0 = _mm_unpacklo_epi8( xmm0,  _mm_setzero_si128() );
                xmm0 = _mm_slli_epi32( xmm0, 6 );
                xmm0 = _mm_mulhi_epi16( xmm0, coe0 );
                xmm0 = _mm_add_epi16( xmm0, coe1 );
                _mm_stream_si32( (int *)ycp2 + 0, _mm_cvtsi128_si32( xmm0 ) );
                _mm_stream_si32( (int *)ycp2 + 1, _mm_cvtsi128_si32( _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 4, 3, 2, 3 ) ) ) );
                _mm_stream_si32( (int *)ycp2 + 2, _mm_cvtsi128_si32( _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 4, 3, 3, 1 ) ) ) );
                pixelp2 += 4;
                ycp2 += 2;
            }
        }
        else
        {
            // o͑ACgĂȂ
            // i _mm_stream_si128  _mm_storeu_si128 ɒuj
            // 4pbN8sNZ
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)pixelp2 + pixel_line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i xmm0 = _mm_loadu_si128( (__m128i *)pixelp2 );
                __m128i xmm1 = xmm0;

                xmm0 = _mm_unpacklo_epi8( xmm0,  _mm_setzero_si128() );
                xmm0 = _mm_slli_epi32( xmm0, 6 );
                xmm0 = _mm_mulhi_epi16( xmm0, coe0 );
                xmm0 = _mm_add_epi16( xmm0, coe1 );

                xmm1 = _mm_unpackhi_epi8( xmm1,  _mm_setzero_si128() );
                xmm1 = _mm_slli_epi32( xmm1, 6 );
                xmm1 = _mm_mulhi_epi16( xmm1, coe0 );
                xmm1 = _mm_add_epi16( xmm1, coe1 );

                __m128i lo0 = _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 2, 3, 1, 0 ) );
                __m128i hi0 = _mm_srli_si128( _mm_shufflelo_epi16( xmm0, _MM_SHUFFLE( 3, 1, 1, 0 ) ), 4 );
                _mm_storeu_si128( (__m128i *)ycp2 + 0, _mm_unpacklo_epi64( lo0, hi0 ) );

                __m128i lo1 = _mm_shufflelo_epi16( _mm_srli_si128( xmm0, 8 ), _MM_SHUFFLE( 3, 1, 2, 3 ) );
                __m128i hi1 = _mm_shufflelo_epi16( xmm1, _MM_SHUFFLE( 2, 3, 1, 0 ) );
                _mm_storeu_si128( (__m128i *)ycp2 + 1, _mm_unpacklo_epi64( lo1, hi1 ) );

                __m128i lo2 = _mm_slli_si128( _mm_shufflelo_epi16( xmm1, _MM_SHUFFLE( 3, 1, 1, 0 ) ), 4 );
                __m128i hi2 = _mm_shufflehi_epi16( xmm1, _MM_SHUFFLE( 3, 1, 2, 3 ) );
                _mm_storeu_si128( (__m128i *)ycp2 + 2, _mm_unpackhi_epi64( lo2, hi2 ) );

                pixelp2 += 16;
                ycp2 += 8;
            }
            // [1pbN2sNZ
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( *(DWORD *)pixelp2 );
                xmm0 = _mm_unpacklo_epi8( xmm0,  _mm_setzero_si128() );
                xmm0 = _mm_slli_epi32( xmm0, 6 );
                xmm0 = _mm_mulhi_epi16( xmm0, coe0 );
                xmm0 = _mm_add_epi16( xmm0, coe1 );
                ycp2[0].y  = _mm_extract_epi16( xmm0, 0 );
                ycp2[0].cb = _mm_extract_epi16( xmm0, 1 );
                ycp2[0].cr = _mm_extract_epi16( xmm0, 3 );
                ycp2[1].y  = _mm_extract_epi16( xmm0, 2 );
                ycp2[1].cb = _mm_extract_epi16( xmm0, 1 );
                ycp2[1].cr = _mm_extract_epi16( xmm0, 3 );
                pixelp2 += 4;
                ycp2 += 2;
            }
        }
    }
}

//---------------------------------------------------------------------
// [Xbh] YC48 -> YUY2iXg[gɕϊj
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_yc2pixel_yuy2_scaling( int thread_id, int thread_num, void *param1, void *param2 )
{
    // l[
    const COLOR_PROC_INFO *cpip  = (COLOR_PROC_INFO *)param1;

    // [JϐɃRs[
    const int line_size = cpip->line_size;
    const int w         = cpip->w;
    const int h         = cpip->h;
    PIXEL_YC *ycp       = cpip->ycp;
    DWORD *pixelp       = (DWORD *)cpip->pixelp;

	// ̂ŁAXbh𔼕ɂė̏Ƀ\[X
	if( thread_id < 0 || thread_num <= 0 ) return; // 肦ȂlȂ̂
	if( thread_id & 0x1 ) return; // eîݎcj
	thread_id = thread_id >> 1;
	thread_num = (thread_num + 1 ) >> 1;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // W萔
    const int pixel_line_size = ((w+1)/2*4);

    //
    // Y0 = (( ( y0*219 +   0*219)  + 2048) >> 12) + 16
    // U =  (( (cb0*112 + cb1*112)  + 2048) >> 12) + 128
    // Y1 = (( ( y1*219 +   0*219)  + 2048) >> 12) + 16
    // V =  (( (cr0*112 + cr1*112)  + 2048) >> 12) + 128
    // 
    // ό`
    // Y0 = ( ( y0*219 +   0*219)  + 2048+ 16*4096 ) >> 12
    // U =  ( (cb0*112 + cb1*112)  + 2048+128*4096 ) >> 12
    // Y1 = ( ( y1*219 +   0*219)  + 2048+ 16*4096 ) >> 12
    // V =  ( (cr0*112 + cr1*112)  + 2048+128*4096 ) >> 12
    //                               
    //               coe0            coe1
    const __m128i coe0 = _mm_setr_epi16( 219, 0, 112, 112, 219, 0, 112, 112 );
    const __m128i coe1 = _mm_setr_epi32( 2048+ 16*4096, 2048+128*4096, 2048+ 16*4096, 2048+128*4096 );

    for( int y = y_start; y < y_end; y++ )
    {
        const PIXEL_YC * ycp2 = (PIXEL_YC *)( (BYTE *)ycp + y * line_size );
        unsigned int * pixelp2 = (unsigned int *)( (BYTE *)pixelp + y * pixel_line_size );

        int x = 0;

        // o͑̃|C^16byteACgɑB
        // 蔲̂߁ApaddingŒł4byteɑĂ  xȏ̉KvB
        intptr_t padding = ( 0 - (intptr_t)pixelp2 ) & 0xF;
        if( w > 31 && !(padding & 0x3) )
        {
            padding >>= 1; // ̂ɕKvȃsNZ

            _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

            // i2sNZ1pbNj
            for( ; x < padding; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( ycp2[0].y );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cb, 2 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cr, 6 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].y,  4 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cb, 3 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cr, 7 );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), coe1 ), 12 );
                xmm0 = _mm_packs_epi32( xmm0, xmm0 );
                xmm0 = _mm_packus_epi16( xmm0, xmm0 );
                _mm_stream_si32( (int *)pixelp2, _mm_cvtsi128_si32( xmm0 ) );
                ycp2 += 2;
                pixelp2++;
            }
            // ACgĂ
            // 8sNZ4pbN
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i in0 = _mm_loadu_si128( (__m128i *)ycp2     );
                __m128i in1 = _mm_loadu_si128( (__m128i *)ycp2 + 1 );
                __m128i in2 = _mm_loadu_si128( (__m128i *)ycp2 + 2 );
                __m128i xmm0, xmm1;
                {
                    __m128i t0 = _mm_shuffle_epi32( in0, _MM_SHUFFLE( 1, 2, 2, 0 ) );
                    t0 = _mm_shufflelo_epi16( t0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                    t0 = _mm_shufflehi_epi16( t0, _MM_SHUFFLE( 1, 2, 1, 3 ) );

                    __m128i t1 = _mm_unpacklo_epi64( _mm_srli_si128( in0, 8 ), in1 );
                    t1 = _mm_shuffle_epi32( t1, _MM_SHUFFLE( 3, 2, 1, 3 ) );
                    t1 = _mm_shufflelo_epi16( t1, _MM_SHUFFLE( 0, 3, 1, 2 ) );
                    t1 = _mm_shufflehi_epi16( t1, _MM_SHUFFLE( 3, 0, 1, 1 ) );

                    t0 = _mm_madd_epi16( t0, coe0 ); t1 = _mm_madd_epi16( t1, coe0 );
                    t0 = _mm_add_epi32( t0, coe1 );  t1 = _mm_add_epi32( t1, coe1 );
                    t0 = _mm_srai_epi32( t0, 12 );   t1 = _mm_srai_epi32( t1, 12 );
                    xmm0 = _mm_packs_epi32( t0, t1 );
                }
                {
                    __m128i t0 = _mm_unpacklo_epi64( _mm_srli_si128( in1, 8 ), in2 );
                    t0 = _mm_shuffle_epi32( t0, _MM_SHUFFLE( 2, 1, 2, 0 ) );
                    t0 = _mm_shufflelo_epi16( t0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                    t0 = _mm_shufflehi_epi16( t0, _MM_SHUFFLE( 3, 0, 1, 1 ) );

                    __m128i t1 = _mm_shuffle_epi32( in2, _MM_SHUFFLE( 3, 2, 1, 3 ) );
                    t1 = _mm_shufflelo_epi16( t1, _MM_SHUFFLE( 0, 3, 1, 2 ) );
                    t1 = _mm_shufflehi_epi16( t1, _MM_SHUFFLE( 3, 0, 1, 1 ) );

                    t0 = _mm_madd_epi16( t0, coe0 ); t1 = _mm_madd_epi16( t1, coe0 );
                    t0 = _mm_add_epi32( t0, coe1 );  t1 = _mm_add_epi32( t1, coe1 );
                    t0 = _mm_srai_epi32( t0, 12 );   t1 = _mm_srai_epi32( t1, 12 );
                    xmm1 = _mm_packs_epi32( t0, t1 );
                }

                _mm_stream_si128( (__m128i *)pixelp2, _mm_packus_epi16( xmm0, xmm1 ) ); // o

                ycp2 += 8;
                pixelp2 += 4;
            }
            // 2sNZ1pbNi_mm_stream_si32gpj
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( ycp2[0].y );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cb, 2 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cr, 6 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].y,  4 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cb, 3 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cr, 7 );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), coe1 ), 12 );
                xmm0 = _mm_packs_epi32( xmm0, xmm0 );
                xmm0 = _mm_packus_epi16( xmm0, xmm0 );
                _mm_stream_si32( (int *)pixelp2, _mm_cvtsi128_si32( xmm0 ) );
                ycp2 += 2;
                pixelp2++;
            }
        }
        else
        {
            // ACgĂȂ
            // i _mm_stream_si128  _mm_storeu_si128 ɒuj
            // 8sNZ4pbN
            for( ; x < w - 6; x += 8 )
            {
                _mm_prefetch( (BYTE *)ycp2 + line_size, _MM_HINT_NTA ); // ̃CvtFb`

                __m128i in0 = _mm_loadu_si128( (__m128i *)ycp2     );
                __m128i in1 = _mm_loadu_si128( (__m128i *)ycp2 + 1 );
                __m128i in2 = _mm_loadu_si128( (__m128i *)ycp2 + 2 );
                __m128i xmm0, xmm1;
                {
                    __m128i t0 = _mm_shuffle_epi32( in0, _MM_SHUFFLE( 1, 2, 2, 0 ) );
                    t0 = _mm_shufflelo_epi16( t0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                    t0 = _mm_shufflehi_epi16( t0, _MM_SHUFFLE( 1, 2, 1, 3 ) );

                    __m128i t1 = _mm_unpacklo_epi64( _mm_srli_si128( in0, 8 ), in1 );
                    t1 = _mm_shuffle_epi32( t1, _MM_SHUFFLE( 3, 2, 1, 3 ) );
                    t1 = _mm_shufflelo_epi16( t1, _MM_SHUFFLE( 0, 3, 1, 2 ) );
                    t1 = _mm_shufflehi_epi16( t1, _MM_SHUFFLE( 3, 0, 1, 1 ) );

                    t0 = _mm_madd_epi16( t0, coe0 ); t1 = _mm_madd_epi16( t1, coe0 );
                    t0 = _mm_add_epi32( t0, coe1 );  t1 = _mm_add_epi32( t1, coe1 );
                    t0 = _mm_srai_epi32( t0, 12 );   t1 = _mm_srai_epi32( t1, 12 );
                    xmm0 = _mm_packs_epi32( t0, t1 );
                }
                {
                    __m128i t0 = _mm_unpacklo_epi64( _mm_srli_si128( in1, 8 ), in2 );
                    t0 = _mm_shuffle_epi32( t0, _MM_SHUFFLE( 2, 1, 2, 0 ) );
                    t0 = _mm_shufflelo_epi16( t0, _MM_SHUFFLE( 2, 1, 1, 0 ) );
                    t0 = _mm_shufflehi_epi16( t0, _MM_SHUFFLE( 3, 0, 1, 1 ) );

                    __m128i t1 = _mm_shuffle_epi32( in2, _MM_SHUFFLE( 3, 2, 1, 3 ) );
                    t1 = _mm_shufflelo_epi16( t1, _MM_SHUFFLE( 0, 3, 1, 2 ) );
                    t1 = _mm_shufflehi_epi16( t1, _MM_SHUFFLE( 3, 0, 1, 1 ) );

                    t0 = _mm_madd_epi16( t0, coe0 ); t1 = _mm_madd_epi16( t1, coe0 );
                    t0 = _mm_add_epi32( t0, coe1 );  t1 = _mm_add_epi32( t1, coe1 );
                    t0 = _mm_srai_epi32( t0, 12 );   t1 = _mm_srai_epi32( t1, 12 );
                    xmm1 = _mm_packs_epi32( t0, t1 );
                }

                _mm_storeu_si128( (__m128i *)pixelp2, _mm_packus_epi16( xmm0, xmm1 ) ); // o

                ycp2 += 8;
                pixelp2 += 4;
            }
            // 2sNZ1pbNi_mm_stream_si32gpj
            for( ; x < w; x += 2 )
            {
                __m128i xmm0 = _mm_cvtsi32_si128( ycp2[0].y );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cb, 2 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[0].cr, 6 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].y,  4 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cb, 3 );
                xmm0 = _mm_insert_epi16( xmm0, ycp2[1].cr, 7 );
                xmm0 = _mm_srai_epi32( _mm_add_epi32( _mm_madd_epi16( xmm0, coe0 ), coe1 ), 12 );
                xmm0 = _mm_packs_epi32( xmm0, xmm0 );
                xmm0 = _mm_packus_epi16( xmm0, xmm0 );
                *(int *)pixelp2 = _mm_cvtsi128_si32( xmm0 );
                ycp2 += 2;
                pixelp2++;
            }
        }
    }
}
