//--------------------------------------------------------------------
// ԂȂ(BT.709)(BT.601)̃C
//--------------------------------------------------------------------
#include <windows.h>
#include <mmintrin.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include "color.h"

#include "rgb2yuy2.h"

//---------------------------------------------------------------------
// FϊvOC\̒`
//---------------------------------------------------------------------
COLOR_PLUGIN_TABLE color_plugin_table = {
    0,
    (TCHAR*)"ԂȂ(BT.709)(BT.601)",
    (TCHAR*)"ԂȂ(BT.709)(BT.601) " RGB2YUY2_VERSION " by ۂ",
    func_init,
    NULL,
    func_pixel2yc,
    func_yc2pixel,
};

//---------------------------------------------------------------------
// SIMD̃tO
//---------------------------------------------------------------------
#define FLAG_MMX  0x800000
#define FLAG_SSE  0x2000000
#define FLAG_SSE2 0x4000000

__declspec(noinline) int cpuid_simd()
{
    int flag;
    __asm volatile (
        "movl $1,%%eax   \n"
        "cpuid           \n"
        "movl %%edx,%0   \n"
        : "=m" (flag)
        :
        : "%eax", "%ebx", "%ecx", "%edx" // 4ޔȂƃoO
    );
    return flag; 
}

//---------------------------------------------------------------------
// FϊvOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C COLOR_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetColorPluginTable( void )
{
    if( !(cpuid_simd() & FLAG_SSE2) ) return NULL; //  AviUtl{̂ɔC
    return &color_plugin_table;
}

//---------------------------------------------------------------------
// DLLJnɌĂ΂
//---------------------------------------------------------------------
BOOL func_init()
{
    if( !(cpuid_simd() & FLAG_SSE2) ) return FALSE; //  AviUtl{̂ɔC
    return TRUE;
}

//---------------------------------------------------------------------
// ͕ϊAAviUtlĂ΂
//---------------------------------------------------------------------
BOOL func_pixel2yc( COLOR_PROC_INFO *cpip )
{
    if( !(cpuid_simd() & FLAG_SSE2) ) return FALSE; //  AviUtl{̂ɔC

    if( cpip->format == MAKEFOURCC('Y','U','Y','2') )
    {
        // YUY2
        int convert_mode = 1;
        cpip->exec_multi_thread_func( thread_pixel2yc_yuy2_convert, (void *)cpip, (void *)&convert_mode );
    }
    else if( cpip->format == 0 )
    {
        // RGB24
        int convert_mode = 1;
        cpip->exec_multi_thread_func( thread_pixel2yc_rgb24, (void *)cpip, (void *)&convert_mode );
    }
    else if( cpip->format == MAKEFOURCC('Y','C','4','8') )
    {
        // YC48
        int convert_mode = 1;
        cpip->exec_multi_thread_func( thread_pixel2yc_yc48_convert, (void *)cpip, (void *)&convert_mode );
    }
    else
    {
        //  AviUtl{̂ɔC
        return FALSE;
    }

    return TRUE;
}

//---------------------------------------------------------------------
// o͕ϊAAviUtlĂ΂
//---------------------------------------------------------------------
BOOL func_yc2pixel( COLOR_PROC_INFO *cpip )
{
    if( !(cpuid_simd() & FLAG_SSE2) ) return FALSE; //  AviUtl{̂ɔC

    if( cpip->format == MAKEFOURCC('Y','U','Y','2') )
    {
        // YUY2
        int convert_mode = 1;
        cpip->exec_multi_thread_func( thread_yc2pixel_yuy2_convert, (void *)cpip, (void *)&convert_mode );
    }
    else if( cpip->format == 0 )
    {
        // RG24
        int convert_mode = 1;
        cpip->exec_multi_thread_func( thread_yc2pixel_rgb24, (void *)cpip, (void *)&convert_mode );
    }
    else if( cpip->format == MAKEFOURCC('Y','C','4','8') )
    {
        // YC48
        int convert_mode = 1;
        cpip->exec_multi_thread_func( thread_yc2pixel_yc48_convert, (void *)cpip, (void *)&convert_mode );
    }
    else
    {
        //  AviUtl{̂ɔC
        return FALSE;
    }

    return TRUE;
}

